/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package at.eurotours.bugs.gf6329;

import java.io.IOException;
import java.util.Arrays;
import java.util.Enumeration;
import java.util.Map;
import java.util.Set;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;

public class LogFilter implements Filter 
{

    private FilterConfig filterConfig = null;

    public LogFilter() 
    {
    } 

    
    public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException
    {
      
        HttpServletRequest httpRequest = (HttpServletRequest)request;
        dumpParams(request);
        BufferedRequestWrapper bufferedRequest= new BufferedRequestWrapper(httpRequest);
        dumpParams(request);
        chain.doFilter(request, response);

    }
  
    public FilterConfig getFilterConfig() 
    {
	return (this.filterConfig);
    }

    public void setFilterConfig(FilterConfig filterConfig) 
    {
	this.filterConfig = filterConfig;
    }

    public void destroy() 
    { 
        filterConfig = null;  
    }


    public void init(FilterConfig filterConfig) 
    { 
	this.filterConfig = filterConfig;
	if (filterConfig != null) 
        {
	}
    }

    public String toString() 
    {
	if (filterConfig == null) return ("LogFilter()");
	StringBuffer sb = new StringBuffer("LogFilter(");
	sb.append(filterConfig);
	sb.append(")");
	return (sb.toString());
    }

    private void dumpParams(ServletRequest request) {
        final Set<Map.Entry> set = request.getParameterMap().entrySet();
        for (Map.Entry entry : set) {
            System.out.println(entry.getKey() + ":" + Arrays.asList((String[])entry.getValue()));
        }
    }

}